﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace ColumnsAcrossPages_CS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void TrackBar1_Scroll(object sender, EventArgs e)
        {
            TextBox1.Text = TrackBar1.Value.ToString();
        }

        private void Button1_Click(object sender, EventArgs e)
        {
            GrapeCity.ActiveReports.SectionReport ar = default(GrapeCity.ActiveReports.SectionReport);
            GrapeCity.ActiveReports.SectionReport ar2 = default(GrapeCity.ActiveReports.SectionReport);

            GrapeCity.ActiveReports.SectionReportModel.TextBox ctl = default(GrapeCity.ActiveReports.SectionReportModel.TextBox);
            DataTable dt = new DataTable();
            dt = GetData(TrackBar1.Value);

            if (dt.Columns.Count > 0)
            {
                ar = GetClearReport();

                for (int i = 2; i <= dt.Columns.Count - 1; i++)
                {
                    if (i < 15)
                    {
                        ctl = new GrapeCity.ActiveReports.SectionReportModel.TextBox();
                        var _with1 = ctl;
                        _with1.Name = "ColN" + (i - 2).ToString();
                        _with1.Text = "ColN" + (i - 2).ToString();
                        _with1.DataField = "ColN" + (i - 2).ToString();
                        _with1.Location = new PointF(0.8f * i, 0.1f);
                        _with1.Size = new SizeF(0.5f, 0.3f);
                        _with1.Border.BottomStyle = GrapeCity.ActiveReports.BorderLineStyle.Solid;
                        ar.Sections[0].Controls.Add(ctl);
                    }
                    else
                    {
                        if (ar2 == null)
                        {
                            ar2 = GetClearReport();
                        }
                        ctl = new GrapeCity.ActiveReports.SectionReportModel.TextBox();
                        var _with2 = ctl;
                        _with2.Name = "ColN" + (i - 2).ToString();
                        _with2.Text = "ColN" + (i - 2).ToString();
                        _with2.DataField = "ColN" + (i - 2).ToString();
                        _with2.Location = new PointF(0.8f + 0.8f * (i - 14), 0.1f);
                        _with2.Size = new SizeF(0.5f, 0.3f);
                        _with2.Border.BottomStyle = GrapeCity.ActiveReports.BorderLineStyle.Solid;
                        ar2.Sections[0].Controls.Add(ctl);
                    }
                }
            }

            if ((ar != null))
            {
                if (ar2 == null)
                {
                    ar.DataSource = dt;
                    ar.Run();
                    Viewer1.Document = ar.Document;
                }
                else
                {
                    ar.DataSource = dt;
                    ar.Run();
                    ar2.DataSource = dt;
                    ar2.Run();
                    GrapeCity.ActiveReports.Document.SectionDocument doc = new GrapeCity.ActiveReports.Document.SectionDocument();
                    for (int i = 0; i <= ar.Document.Pages.Count - 1; i++)
                    {
                        doc.Pages.Add(ar.Document.Pages[i]);
                        doc.Pages.Add(ar2.Document.Pages[i]);
                    }
                    Viewer1.Document = doc;
                }
            }
        }

        private DataTable GetData(int cnum)
        {
            DataTable t = new DataTable();
            int i = 0;
            int j = 0;
            int ij = 0;
            Random r = new Random();

            t.Columns.Add("Years");
            t.Columns.Add("Month");

            for (i = 2; i <= cnum - 1; i++)
            {
                t.Columns.Add("ColN" + (i - 2).ToString());
            }

            DataRow dr = null;

            for (i = 1; i <= 5; i++)
            {
                for (j = 1; j <= 12; j++)
                {
                    dr = t.NewRow();
                    dr[0] = 2000 + i;
                    dr[1] = j;
                    for (ij = 2; ij <= cnum - 1; ij++)
                    {
                        dr[ij] = r.Next(10000, 99999);
                    }
                    t.Rows.Add(dr);
                }
            }

            t.AcceptChanges();
            return t;
        }

        private GrapeCity.ActiveReports.SectionReport GetClearReport()
        {
            GrapeCity.ActiveReports.SectionReport r = new GrapeCity.ActiveReports.SectionReport();

            r.Document.Printer.PrinterName = "";
            r.PageSettings.Orientation = GrapeCity.ActiveReports.Document.Section.PageOrientation.Landscape;
            r.PageSettings.Margins.Left = 0.1f;
            r.PageSettings.Margins.Right = 0.1f;
            r.Document.Printer.Landscape = true;
            r.PrintWidth = 11;

            r.Sections.Add(GrapeCity.ActiveReports.Document.Section.SectionType.Detail, "Detail");
            var _with1 = r.Sections[0];
            _with1.Height = 2f;
            _with1.CanGrow = true;
            _with1.CanShrink = true;

            GrapeCity.ActiveReports.SectionReportModel.TextBox ctl = default(GrapeCity.ActiveReports.SectionReportModel.TextBox);

            ctl = new GrapeCity.ActiveReports.SectionReportModel.TextBox();
            ctl.Name = "Years";
            ctl.Text = "Years";
            ctl.DataField = "Years";
            ctl.Location = new PointF(0.1f, 0.1f);
            ctl.Size = new SizeF(0.7f, 0.3f);
            ctl.Border.BottomStyle = GrapeCity.ActiveReports.BorderLineStyle.Solid;
            ctl.BackColor = Color.Aqua;
            r.Sections[0].Controls.Add(ctl);

            ctl = new GrapeCity.ActiveReports.SectionReportModel.TextBox();
            ctl.Name = "Month";
            ctl.Text = "Month";
            ctl.DataField = "Month";
            ctl.Location = new PointF(0.8f, 0.1f);
            ctl.Size = new SizeF(0.7f, 0.3f);
            ctl.Border.BottomStyle = GrapeCity.ActiveReports.BorderLineStyle.Solid;
            ctl.BackColor = Color.AliceBlue;
            r.Sections[0].Controls.Add(ctl);
            return r;
        }
    }
}
